/*
 
 ** AUTHOR: Marco Bellia
 ** LPL - Matematica
 ** Pisa 2019
 
 */
#include <stdio.h>
#include <stdlib.h>

typedef enum{false,true} bool;
 
//Strutture per rappresentare due tipi "con identica
//struttura di occupazione di memoria"
struct d{
    int Ad;
    char* Bd;
};
struct r{
    char* Br;
    int Ar;
};

//Tipi per abitanti, detenuti
typedef struct d * typeD;
typedef struct r * typeR;

bool showtypeD(typeD p){
    if (p==NULL) return false;
    printf("Ad:%d, Bd:%s\n", p->Ad, p->Bd);
    return true;
}

bool showtypeR(typeR p){
    if (p==NULL) return false;
    printf("Ar: %d, Br:%s\n ", p->Ar, p->Br);
    return true;
}


//
int main(void){
    typeD d1 = malloc(sizeof(typeR));
    d1->Ad = 17;
    d1->Bd = "1372";
    showtypeD(d1);
    typeR r1 = malloc(sizeof(typeD));
    r1->Ar = -15;
    r1->Br = "mario";
    showtypeR(r1);
    return 1;
}

/* Cosa dice la Semantica dei costrutti usati?
 
   compila "perfettamente" anche quando le strutture non
   sono isomorfe (ordine dei conponenti invertito).
   Le variabili d1 ed r1 sono trattate come se typeR e
   typeD fossero uno stesso tipo
 
 MarcoBelliasAir:CastEAllocazione marcob$ cc castEalloca2.c -o cEa2.exe
 MarcoBelliasAir:CastEAllocazione marcob$ ./cEA2.exe
 Ad:17, Bd:1372
 Ar: -15, Br:mario
 MarcoBelliasAir:CastEAllocazione marcob$
 
   Ma e' proprio cosi'? vedi castEalloca3.c
 */
